image: maven:3-jdk-8

stages:
  - build
  - deploy

variables:
  REPO_PROJECT: "org.pragmaticmodeling.pxdoc.uml312.lib.repository"
  REPO_FOLDER: "pxdoc-uml-3.1.2"
  REPO_LABEL: "pxDoc Support for UML 3.1.2"
  REPO_MAIN_FEATURE: "org.pragmaticmodeling.pxdoc.uml312.lib.feature_*.jar"
  NIGHTLY_REPO: "$DEST_FOLDER/$REPO_FOLDER/nightly/"
  
before_script:
  - apt-get update -qq && apt-get install -y -qq sshpass
  - 'which ssh-agent || ( apt-get update -y && apt-get install openssh-client -y )'
  - mkdir -p ~/.ssh
  - eval $(ssh-agent -s)
  - '[[ -f /.dockerenv ]] && echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'
  - ssh-add <(echo "$PRIVATE_KEY")
  - apt-get install -y rsync
  - git config --global user.name "pxDoc Team"
  - git config --global user.email "romain.bernard@pxdoc.fr"

build:
  stage: build
  variables:
    BUILT_REPO: "./$REPO_PROJECT/target/repository/"
    
  script:
    - git clone http://gitlab+deploy-token-14641:${TOOLS_TOKEN}@gitlab.com/eXMS/artifacts-repository.git
    - "mvn clean install -B"
    - nightlyRepo="$NIGHTLY_REPO"
    - builtRepo="$BUILT_REPO"
    - rsync -aOzvcog --delete --chmod=Du=rwx,Dgo=rx,Fu=rw,Fog=r --chown=www-data:www-data --exclude='.*' -e 'ssh -vvv -p 3004' "$builtRepo" "$nightlyRepo"

  artifacts:
    paths:
    - org.pragmaticmodeling.pxdoc.uml312.lib.repository/target/org.pragmaticmodeling.pxdoc.uml312.lib.repository-1.1.1-SNAPSHOT.zip
    expire_in: 1 week

deploy_prod:
  stage: deploy
  variables:
    RELEASE_REPO: "$DEST_FOLDER/$REPO_FOLDER/releases/"
  script:
    - nightlyRepo="$NIGHTLY_REPO"
    - releaseRepo="$RELEASE_REPO"
    - git clone http://gitlab+deploy-token-14641:${TOOLS_TOKEN}@gitlab.com/eXMS/artifacts-repository.git
    - mkdir repository
    - rsync -aOzvcog --delete --chmod=Du=rwx,Dgo=rx,Fu=rw,Fog=r --chown=www-data:www-data --exclude='.*' -e 'ssh -vvv -p 3004' "$nightlyRepo" ./repository/
    - fVar=$(find ./repository/features -type f -name $REPO_MAIN_FEATURE)
    - mkdir product
    - mkdir product/repository
    - rsync -aOzvcog --delete --chmod=Du=rwx,Dgo=rx,Fu=rw,Fog=r --chown=www-data:www-data --exclude='.*' -e 'ssh -vvv -p 3004' "$releaseRepo" ./product/repository/
    - fLauncher=$(find ./artifacts-repository/eclipse/plugins -type f -name 'org.eclipse.equinox.launcher_*.jar')
    - java -jar $fLauncher -application org.eclipse.ant.core.antRunner -buildfile artifacts-repository/releng/packaging-p2composite.ant p2.composite.add -Dsite.label=$REPO_LABEL -Dsoftware.download.area="../../product/repository/" -Dsource.repository="../../repository/" -Dqualified.feature=$fVar
    - rsync -aOzvcog --delete --chmod=Du=rwx,Dgo=rx,Fu=rw,Fog=r --chown=www-data:www-data --exclude='.*' -e 'ssh -vvv -p 3004' ./product/repository/ "$releaseRepo"
  environment:
    name: production
    url: http://www.pxdoc.fr/updates/$REPO_FOLDER/releases
  only:
    - tags
  except:
    - develop